VTK: vtkSelectVisiblePoints Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkSelectVisiblePoints Class Reference

extract points that are visible (based on z-buffer calculation) More...

`#include <vtkSelectVisiblePoints.h>`

Inheritance diagram for vtkSelectVisiblePoints:
[legend]
Collaboration diagram for vtkSelectVisiblePoints:
[legend]

## Public Types
typedef vtkPolyDataAlgorithm | Superclass
Public Types inherited from vtkPolyDataAlgorithm
typedef vtkAlgorithm | Superclass
Public Types inherited from vtkAlgorithm
enum | DesiredOutputPrecision { SINGLE_PRECISION, DOUBLE_PRECISION, DEFAULT_PRECISION }
| Values used for setting the desired output precision for various algorithms. More...
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkSelectVisiblePoints * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetRenderer (vtkRenderer *ren)
| Specify the renderer in which the visibility computation is to be performed. More...
vtkRenderer * | GetRenderer ()
virtual void | SetSelectionWindow (vtkTypeBool)
| Set/Get the flag which enables selection in a rectangular display region. More...
virtual vtkTypeBool | GetSelectionWindow ()
virtual void | SelectionWindowOn ()
virtual void | SelectionWindowOff ()
virtual void | SetSelection (int, int, int, int)
| Specify the selection window in display coordinates. More...
virtual void | SetSelection (int[4])
virtual int * | GetSelection ()
virtual void | GetSelection (int data[4])
virtual void | SetSelectInvisible (vtkTypeBool)
| Set/Get the flag which enables inverse selection; i.e., invisible points are selected. More...
virtual vtkTypeBool | GetSelectInvisible ()
virtual void | SelectInvisibleOn ()
virtual void | SelectInvisibleOff ()
virtual void | SetTolerance (double)
| Set/Get a tolerance in normalized display coordinate system to use to determine whether a point is visible. More...
virtual double | GetTolerance ()
virtual void | SetToleranceWorld (double)
| Set/Get a tolerance in world coordinate system to use to determine whether a point is visible. More...
virtual double | GetToleranceWorld ()
float * | Initialize (bool getZbuff)
| Requires the renderer to be set. More...
bool | IsPointOccluded (const double x[3], const float *zPtr)
| Tests if a point x is being occluded or not against the Z-Buffer array passed in by zPtr. More...
vtkMTimeType | GetMTime () override
| Return MTime also considering the renderer. More...
Public Member Functions inherited from vtkPolyDataAlgorithm
vtkPolyDataAlgorithm * | NewInstance () const
vtkPolyData * | GetOutput ()
| Get the output data object for a port on this algorithm. More...
vtkPolyData * | GetOutput (int)
virtual void | SetOutput (vtkDataObject *d)
vtkTypeBool | ProcessRequest (vtkInformation *, vtkInformationVector **, vtkInformationVector *) override
| see vtkAlgorithm for details More...
vtkDataObject * | GetInput ()
vtkDataObject * | GetInput (int port)
vtkPolyData * | GetPolyDataInput (int port)
void | SetInputData (vtkDataObject *)
| Assign a data object as input. More...
void | SetInputData (int, vtkDataObject *)
void | AddInputData (vtkDataObject *)
| Assign a data object as input. More...
void | AddInputData (int, vtkDataObject *)
Public Member Functions inherited from vtkAlgorithm
vtkAlgorithm * | NewInstance () const
int | HasExecutive ()
| Check whether this algorithm has an assigned executive. More...
vtkExecutive * | GetExecutive ()
| Get this algorithm's executive. More...
virtual void | SetExecutive (vtkExecutive *executive)
| Set this algorithm's executive. More...
vtkTypeBool | ProcessRequest (vtkInformation *request, vtkCollection *inInfo, vtkInformationVector *outInfo)
| Version of ProcessRequest() that is wrapped. More...
virtual int | ComputePipelineMTime (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec, int requestFromOutputPort, vtkMTimeType *mtime)
| A special version of ProcessRequest meant specifically for the pipeline modified time request. More...
virtual int | ModifyRequest (vtkInformation *request, int when)
| This method gives the algorithm a chance to modify the contents of a request before or after (specified in the when argument) it is forwarded. More...
vtkInformation * | GetInputPortInformation (int port)
| Get the information object associated with an input port. More...
vtkInformation * | GetOutputPortInformation (int port)
| Get the information object associated with an output port. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with this algorithm. More...
virtual void | SetInformation (vtkInformation *)
int | GetNumberOfInputPorts ()
| Get the number of input ports used by the algorithm. More...
int | GetNumberOfOutputPorts ()
| Get the number of output ports provided by the algorithm. More...
void | Register (vtkObjectBase *o) override
| Participate in garbage collection. More...
void | UnRegister (vtkObjectBase *o) override
| Decrease the reference count (release by another object). More...
virtual void | SetAbortExecute (vtkTypeBool)
| Set/Get the AbortExecute flag for the process object. More...
virtual vtkTypeBool | GetAbortExecute ()
virtual void | AbortExecuteOn ()
virtual void | AbortExecuteOff ()
virtual double | GetProgress ()
| Get the execution progress of a process object. More...
void | SetProgress (double)
| `SetProgress` is deprecated. More...
void | UpdateProgress (double amount)
| Update the progress of the process object. More...
void | SetProgressShiftScale (double shift, double scale)
| Specify the shift and scale values to use to apply to the progress amount when `UpdateProgress` is called. More...
virtual double | GetProgressShift ()
virtual double | GetProgressScale ()
void | SetProgressText (const char *ptext)
| Set the current text message associated with the progress state. More...
virtual char * | GetProgressText ()
virtual unsigned long | GetErrorCode ()
| The error code contains a possible error that occurred while reading or writing the file. More...
virtual void | SetInputArrayToProcess (int idx, int port, int connection, int fieldAssociation, const char *name)
| Set the input data arrays that this algorithm will process. More...
virtual void | SetInputArrayToProcess (int idx, int port, int connection, int fieldAssociation, int fieldAttributeType)
virtual void | SetInputArrayToProcess (int idx, vtkInformation *info)
virtual void | SetInputArrayToProcess (int idx, int port, int connection, const char *fieldAssociation, const char *attributeTypeorName)
| String based versions of SetInputArrayToProcess(). More...
vtkInformation * | GetInputArrayInformation (int idx)
| Get the info object for the specified input array to this algorithm. More...
void | RemoveAllInputs ()
| Remove all the input data. More...
vtkDataObject * | GetOutputDataObject (int port)
| Get the data object that will contain the algorithm output for the given port. More...
vtkDataObject * | GetInputDataObject (int port, int connection)
| Get the data object that will contain the algorithm input for the given port and given connection. More...
virtual void | SetInputConnection (int port, vtkAlgorithmOutput *input)
| Set the connection for the given input port index. More...
virtual void | SetInputConnection (vtkAlgorithmOutput *input)
virtual void | AddInputConnection (int port, vtkAlgorithmOutput *input)
| Add a connection to the given input port index. More...
virtual void | AddInputConnection (vtkAlgorithmOutput *input)
virtual void | RemoveInputConnection (int port, vtkAlgorithmOutput *input)
| Remove a connection from the given input port index. More...
virtual void | RemoveInputConnection (int port, int idx)
| Remove a connection given by index idx. More...
virtual void | RemoveAllInputConnections (int port)
| Removes all input connections. More...
virtual void | SetInputDataObject (int port, vtkDataObject *data)
| Sets the data-object as an input on the given port index. More...
virtual void | SetInputDataObject (vtkDataObject *data)
virtual void | AddInputDataObject (int port, vtkDataObject *data)
| Add the data-object as an input to this given port. More...
virtual void | AddInputDataObject (vtkDataObject *data)
vtkAlgorithmOutput * | GetOutputPort (int index)
| Get a proxy object corresponding to the given output port of this algorithm. More...
vtkAlgorithmOutput * | GetOutputPort ()
int | GetNumberOfInputConnections (int port)
| Get the number of inputs currently connected to a port. More...
int | GetTotalNumberOfInputConnections ()
| Get the total number of inputs for this algorithm. More...
vtkAlgorithmOutput * | GetInputConnection (int port, int index)
| Get the algorithm output port connected to an input port. More...
vtkAlgorithm * | GetInputAlgorithm (int port, int index, int &algPort)
| Returns the algorithm and the output port index of that algorithm connected to a port-index pair. More...
vtkAlgorithm * | GetInputAlgorithm (int port, int index)
| Returns the algorithm connected to a port-index pair. More...
vtkAlgorithm * | GetInputAlgorithm ()
| Equivalent to GetInputAlgorithm(0, 0). More...
vtkExecutive * | GetInputExecutive (int port, int index)
| Returns the executive associated with a particular input connection. More...
vtkExecutive * | GetInputExecutive ()
| Equivalent to GetInputExecutive(0, 0) More...
vtkInformation * | GetInputInformation (int port, int index)
| Return the information object that is associated with a particular input connection. More...
vtkInformation * | GetInputInformation ()
| Equivalent to GetInputInformation(0, 0) More...
vtkInformation * | GetOutputInformation (int port)
| Return the information object that is associated with a particular output port. More...
virtual void | Update (int port)
| Bring this algorithm's outputs up-to-date. More...
virtual void | Update ()
virtual vtkTypeBool | Update (int port, vtkInformationVector *requests)
| This method enables the passing of data requests to the algorithm to be used during execution (in addition to bringing a particular port up-to-date). More...
virtual vtkTypeBool | Update (vtkInformation *requests)
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual int | UpdatePiece (int piece, int numPieces, int ghostLevels, const int extents[6]=nullptr)
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual int | UpdateExtent (const int extents[6])
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual int | UpdateTimeStep (double time, int piece=-1, int numPieces=1, int ghostLevels=0, const int extents[6]=nullptr)
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual void | UpdateInformation ()
| Bring the algorithm's information up-to-date. More...
virtual void | UpdateDataObject ()
| Create output object(s). More...
virtual void | PropagateUpdateExtent ()
| Propagate meta-data upstream. More...
virtual void | UpdateWholeExtent ()
| Bring this algorithm's outputs up-to-date. More...
void | ConvertTotalInputToPortConnection (int ind, int &port, int &conn)
| Convenience routine to convert from a linear ordering of input connections to a port/connection pair. More...
virtual void | SetReleaseDataFlag (int)
| Turn release data flag on or off for all output ports. More...
virtual int | GetReleaseDataFlag ()
void | ReleaseDataFlagOn ()
void | ReleaseDataFlagOff ()
int | UpdateExtentIsEmpty (vtkInformation *pinfo, vtkDataObject *output)
| This detects when the UpdateExtent will generate no data This condition is satisfied when the UpdateExtent has zero volume (0,-1,...) or the UpdateNumberOfPieces is 0. More...
int | UpdateExtentIsEmpty (vtkInformation *pinfo, int extentType)
int * | GetUpdateExtent ()
| These functions return the update extent for output ports that use 3D extents. More...
int * | GetUpdateExtent (int port)
void | GetUpdateExtent (int &x0, int &x1, int &y0, int &y1, int &z0, int &z1)
void | GetUpdateExtent (int port, int &x0, int &x1, int &y0, int &y1, int &z0, int &z1)
void | GetUpdateExtent (int extent[6])
void | GetUpdateExtent (int port, int extent[6])
int | GetUpdatePiece ()
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdatePiece (int port)
int | GetUpdateNumberOfPieces ()
int | GetUpdateNumberOfPieces (int port)
int | GetUpdateGhostLevel ()
int | GetUpdateGhostLevel (int port)
void | SetProgressObserver (vtkProgressObserver *)
| If an ProgressObserver is set, the algorithm will report progress through it rather than directly. More...
virtual vtkProgressObserver * | GetProgressObserver ()
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkSelectVisiblePoints * | SafeDownCast (vtkObjectBase *o)
static vtkSelectVisiblePoints * | New ()
| Instantiate object with no renderer; window selection turned off; tolerance set to 0.01; and select invisible off. More...
Static Public Member Functions inherited from vtkPolyDataAlgorithm
static vtkPolyDataAlgorithm * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPolyDataAlgorithm * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAlgorithm
static vtkAlgorithm * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAlgorithm * | SafeDownCast (vtkObjectBase *o)
static vtkInformationIntegerKey * | INPUT_IS_OPTIONAL ()
| Keys used to specify input port requirements. More...
static vtkInformationIntegerKey * | INPUT_IS_REPEATABLE ()
static vtkInformationInformationVectorKey * | INPUT_REQUIRED_FIELDS ()
static vtkInformationStringVectorKey * | INPUT_REQUIRED_DATA_TYPE ()
static vtkInformationInformationVectorKey * | INPUT_ARRAYS_TO_PROCESS ()
static vtkInformationIntegerKey * | INPUT_PORT ()
static vtkInformationIntegerKey * | INPUT_CONNECTION ()
static vtkInformationIntegerKey * | CAN_PRODUCE_SUB_EXTENT ()
| This key tells the executive that a particular output port is capable of producing an arbitrary subextent of the whole extent. More...
static vtkInformationIntegerKey * | CAN_HANDLE_PIECE_REQUEST ()
| Key that tells the pipeline that a particular algorithm can or cannot handle piece request. More...
static void | SetDefaultExecutivePrototype (vtkExecutive *proto)
| If the DefaultExecutivePrototype is set, a copy of it is created in CreateDefaultExecutive() using NewInstance(). More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkSelectVisiblePoints ()
| ~vtkSelectVisiblePoints () override
int | RequestData (vtkInformation *, vtkInformationVector **, vtkInformationVector *) override
| This is called by the superclass. More...
int | FillInputPortInformation (int port, vtkInformation *info) override
| Fill the input port information objects for this algorithm. More...
Protected Member Functions inherited from vtkPolyDataAlgorithm
| vtkPolyDataAlgorithm ()
| ~vtkPolyDataAlgorithm () override
virtual int | RequestInformation (vtkInformation *request, vtkInformationVector **inputVector, vtkInformationVector *outputVector)
virtual int | RequestUpdateExtent (vtkInformation *, vtkInformationVector **, vtkInformationVector *)
| This is called by the superclass. More...
int | FillOutputPortInformation (int port, vtkInformation *info) override
| Fill the output port information objects for this algorithm. More...
Protected Member Functions inherited from vtkAlgorithm
| vtkAlgorithm ()
| ~vtkAlgorithm () override
virtual void | SetNumberOfInputPorts (int n)
| Set the number of input ports used by the algorithm. More...
virtual void | SetNumberOfOutputPorts (int n)
| Set the number of output ports provided by the algorithm. More...
int | InputPortIndexInRange (int index, const char *action)
int | OutputPortIndexInRange (int index, const char *action)
int | GetInputArrayAssociation (int idx, vtkInformationVector **inputVector)
| Get the assocition of the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
int | GetInputArrayAssociation (int idx, int connection, vtkInformationVector **inputVector)
| Filters that have multiple connections on one port can use this signature. More...
int | GetInputArrayAssociation (int idx, vtkDataObject *input)
vtkDataArray * | GetInputArrayToProcess (int idx, vtkInformationVector **inputVector)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkDataArray * | GetInputArrayToProcess (int idx, vtkInformationVector **inputVector, int &association)
vtkDataArray * | GetInputArrayToProcess (int idx, int connection, vtkInformationVector **inputVector)
| Filters that have multiple connections on one port can use this signature. More...
vtkDataArray * | GetInputArrayToProcess (int idx, int connection, vtkInformationVector **inputVector, int &association)
vtkDataArray * | GetInputArrayToProcess (int idx, vtkDataObject *input)
vtkDataArray * | GetInputArrayToProcess (int idx, vtkDataObject *input, int &association)
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkInformationVector **inputVector)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkInformationVector **inputVector, int &association)
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, int connection, vtkInformationVector **inputVector)
| Filters that have multiple connections on one port can use this signature. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, int connection, vtkInformationVector **inputVector, int &association)
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkDataObject *input)
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkDataObject *input, int &association)
vtkInformation * | GetInputArrayFieldInformation (int idx, vtkInformationVector **inputVector)
| This method takes in an index (as specified in SetInputArrayToProcess) and a pipeline information vector. More...
virtual vtkExecutive * | CreateDefaultExecutive ()
| Create a default executive. More...
virtual void | SetErrorCode (unsigned long)
| The error code contains a possible error that occurred while reading or writing the file. More...
void | ReportReferences (vtkGarbageCollector *) override
virtual void | SetNthInputConnection (int port, int index, vtkAlgorithmOutput *input)
| Replace the Nth connection on the given input port. More...
virtual void | SetNumberOfInputConnections (int port, int n)
| Set the number of input connections on the given input port. More...
void | SetInputDataInternal (int port, vtkDataObject *input)
| These methods are used by subclasses to implement methods to set data objects directly as input. More...
void | AddInputDataInternal (int port, vtkDataObject *input)
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkRenderer * | Renderer
vtkMatrix4x4 * | CompositePerspectiveTransform
vtkTypeBool | SelectionWindow
int | Selection [4]
int | InternalSelection [4]
vtkTypeBool | SelectInvisible
double | DirectionOfProjection [3]
double | Tolerance
double | ToleranceWorld
Protected Attributes inherited from vtkAlgorithm
vtkInformation * | Information
unsigned long | ErrorCode
double | Progress
char * | ProgressText
vtkProgressObserver * | ProgressObserver
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Public Attributes inherited from vtkAlgorithm
vtkTypeBool | AbortExecute
Static Protected Member Functions inherited from vtkAlgorithm
static vtkInformationIntegerKey * | PORT_REQUIREMENTS_FILLED ()
Static Protected Attributes inherited from vtkAlgorithm
static vtkExecutive * | DefaultExecutivePrototype

## Detailed Description

extract points that are visible (based on z-buffer calculation)

vtkSelectVisiblePoints is a filter that selects points based on whether they are visible or not. Visibility is determined by accessing the z-buffer of a rendering window. (The position of each input point is converted into display coordinates, and then the z-value at that point is obtained. If within the user-specified tolerance, the point is considered visible.)

Points that are visible (or if the ivar SelectInvisible is on, invisible points) are passed to the output. Associated data attributes are passed to the output as well.

This filter also allows you to specify a rectangular window in display (pixel) coordinates in which the visible points must lie. This can be used as a sort of local "brushing" operation to select just data within a window.

Warning
  You must carefully synchronize the execution of this filter. The filter refers to a renderer, which is modified every time a render occurs. Therefore, the filter is always out of date, and always executes. You may have to perform two rendering passes, or if you are using this filter in conjunction with vtkLabeledDataMapper, things work out because 2D rendering occurs after the 3D rendering.

Definition at line 54 of file vtkSelectVisiblePoints.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPolyDataAlgorithm vtkSelectVisiblePoints::Superclass

Definition at line 57 of file vtkSelectVisiblePoints.h.

## Constructor & Destructor Documentation

## ◆ vtkSelectVisiblePoints()

vtkSelectVisiblePoints::vtkSelectVisiblePoints | ( |  | ) |
| protected

## ◆ ~vtkSelectVisiblePoints()

vtkSelectVisiblePoints::~vtkSelectVisiblePoints | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkSelectVisiblePoints::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkSelectVisiblePoints::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkPolyDataAlgorithm.

## ◆ SafeDownCast()

static vtkSelectVisiblePoints* vtkSelectVisiblePoints::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSelectVisiblePoints::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkPolyDataAlgorithm.

## ◆ NewInstance()

vtkSelectVisiblePoints* vtkSelectVisiblePoints::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkSelectVisiblePoints::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkPolyDataAlgorithm.

## ◆ New()

static vtkSelectVisiblePoints* vtkSelectVisiblePoints::New | ( |  | ) |
| static

Instantiate object with no renderer; window selection turned off; tolerance set to 0.01; and select invisible off.

## ◆ SetRenderer()

void vtkSelectVisiblePoints::SetRenderer | ( | vtkRenderer * | ren | ) |
| inline

Specify the renderer in which the visibility computation is to be performed.

Definition at line 71 of file vtkSelectVisiblePoints.h.

## ◆ GetRenderer()

vtkRenderer* vtkSelectVisiblePoints::GetRenderer | ( |  | ) |
| inline

Definition at line 79 of file vtkSelectVisiblePoints.h.

## ◆ SetSelectionWindow()

virtual void vtkSelectVisiblePoints::SetSelectionWindow | ( | vtkTypeBool |  | ) |
| virtual

Set/Get the flag which enables selection in a rectangular display region.

## ◆ GetSelectionWindow()

virtual vtkTypeBool vtkSelectVisiblePoints::GetSelectionWindow | ( |  | ) |
| virtual

## ◆ SelectionWindowOn()

virtual void vtkSelectVisiblePoints::SelectionWindowOn | ( |  | ) |
| virtual

## ◆ SelectionWindowOff()

virtual void vtkSelectVisiblePoints::SelectionWindowOff | ( |  | ) |
| virtual

## ◆ SetSelection() [1/2]

virtual void vtkSelectVisiblePoints::SetSelection | ( | int | ,
|  | int | ,
|  | int | ,
|  | int |
| ) |  |
| virtual

Specify the selection window in display coordinates.

You must specify a rectangular region using (xmin,xmax,ymin,ymax).

## ◆ SetSelection() [2/2]

virtual void vtkSelectVisiblePoints::SetSelection | ( | int | [4] | ) |
| virtual

## ◆ GetSelection() [1/2]

virtual int* vtkSelectVisiblePoints::GetSelection | ( |  | ) |
| virtual

## ◆ GetSelection() [2/2]

virtual void vtkSelectVisiblePoints::GetSelection | ( | int | data[4] | ) |
| virtual

## ◆ SetSelectInvisible()

virtual void vtkSelectVisiblePoints::SetSelectInvisible | ( | vtkTypeBool |  | ) |
| virtual

Set/Get the flag which enables inverse selection; i.e., invisible points are selected.

## ◆ GetSelectInvisible()

virtual vtkTypeBool vtkSelectVisiblePoints::GetSelectInvisible | ( |  | ) |
| virtual

## ◆ SelectInvisibleOn()

virtual void vtkSelectVisiblePoints::SelectInvisibleOn | ( |  | ) |
| virtual

## ◆ SelectInvisibleOff()

virtual void vtkSelectVisiblePoints::SelectInvisibleOff | ( |  | ) |
| virtual

## ◆ SetTolerance()

virtual void vtkSelectVisiblePoints::SetTolerance | ( | double |  | ) |
| virtual

Set/Get a tolerance in normalized display coordinate system to use to determine whether a point is visible.

A tolerance is usually required because the conversion from world space to display space during rendering introduces numerical round-off.

## ◆ GetTolerance()

virtual double vtkSelectVisiblePoints::GetTolerance | ( |  | ) |
| virtual

## ◆ SetToleranceWorld()

virtual void vtkSelectVisiblePoints::SetToleranceWorld | ( | double |  | ) |
| virtual

Set/Get a tolerance in world coordinate system to use to determine whether a point is visible.

This allows determining visibility of small spheroid objects (such as glyphs) with known size in world coordinates. By default it is set to 0.

## ◆ GetToleranceWorld()

virtual double vtkSelectVisiblePoints::GetToleranceWorld | ( |  | ) |
| virtual

## ◆ Initialize()

float* vtkSelectVisiblePoints::Initialize | ( | bool | getZbuff | ) |

Requires the renderer to be set.

Populates the composite perspective transform and returns a pointer to the Z-buffer (that must be deleted) if getZbuff is set.

## ◆ IsPointOccluded()

bool vtkSelectVisiblePoints::IsPointOccluded | ( | const double | x[3],
|  | const float * | zPtr
| ) |  |

Tests if a point x is being occluded or not against the Z-Buffer array passed in by zPtr.

Call Initialize before calling this method.

## ◆ GetMTime()

vtkMTimeType vtkSelectVisiblePoints::GetMTime | ( |  | ) |
| overridevirtual

Return MTime also considering the renderer.

Reimplemented from vtkObject.

## ◆ RequestData()

int vtkSelectVisiblePoints::RequestData | ( | vtkInformation * | request,
|  | vtkInformationVector ** | inputVector,
|  | vtkInformationVector * | outputVector
| ) |  |
| overrideprotectedvirtual

This is called by the superclass.

This is the method you should override.

Reimplemented from vtkPolyDataAlgorithm.

## ◆ FillInputPortInformation()

int vtkSelectVisiblePoints::FillInputPortInformation | ( | int | port,
|  | vtkInformation * | info
| ) |  |
| overrideprotectedvirtual

Fill the input port information objects for this algorithm.

This is invoked by the first call to GetInputPortInformation for each port so subclasses can specify what they can handle.

Reimplemented from vtkPolyDataAlgorithm.

## Member Data Documentation

## ◆ Renderer

vtkRenderer* vtkSelectVisiblePoints::Renderer
| protected

Definition at line 158 of file vtkSelectVisiblePoints.h.

## ◆ CompositePerspectiveTransform

vtkMatrix4x4* vtkSelectVisiblePoints::CompositePerspectiveTransform
| protected

Definition at line 159 of file vtkSelectVisiblePoints.h.

## ◆ SelectionWindow

vtkTypeBool vtkSelectVisiblePoints::SelectionWindow
| protected

Definition at line 161 of file vtkSelectVisiblePoints.h.

## ◆ Selection

int vtkSelectVisiblePoints::Selection[4]
| protected

Definition at line 162 of file vtkSelectVisiblePoints.h.

## ◆ InternalSelection

int vtkSelectVisiblePoints::InternalSelection[4]
| protected

Definition at line 163 of file vtkSelectVisiblePoints.h.

## ◆ SelectInvisible

vtkTypeBool vtkSelectVisiblePoints::SelectInvisible
| protected

Definition at line 164 of file vtkSelectVisiblePoints.h.

## ◆ DirectionOfProjection

double vtkSelectVisiblePoints::DirectionOfProjection[3]
| protected

Definition at line 165 of file vtkSelectVisiblePoints.h.

## ◆ Tolerance

double vtkSelectVisiblePoints::Tolerance
| protected

Definition at line 166 of file vtkSelectVisiblePoints.h.

## ◆ ToleranceWorld

double vtkSelectVisiblePoints::ToleranceWorld
| protected

Definition at line 167 of file vtkSelectVisiblePoints.h.

The documentation for this class was generated from the following file:

- Rendering/Core/vtkSelectVisiblePoints.h